#include "hbclass.ch"
#include "common.ch"
#include "hbqtgui.ch"

CLASS RESOURCE FROM APPLICATION

   // Methods
   METHOD New
   METHOD RegisterResource
   METHOD UnRegisterResources

END CLASS

METHOD New CLASS RESOURCE

   LOCAL cResFileName
   LOCAL cPath, cFile, cExt
   
   HB_FNAMESPLIT( HB_PROGNAME(), @cPath, @cFile, @cExt )

   IF ::s_qRes == NIL
      ::s_qRes := QResource()
      cResFileName := "HBQTRES_" + cFile + "()"
      IF TYPE( cResFileName ) == "UI"
         ::s_qRes:registerResource_1( &cResFileName )
         AADD( ::s_aResources, cResFileName )
      ENDIF
   ENDIF

   RETURN Self

METHOD RegisterResource( cResource )

   LOCAL cResFileName := "HBQTRES_" + ALLTRIM( cResource ) + "()"

   IF TYPE( cResFileName ) == "UI"
      ::s_qRes:registerResource_1( &cResFileName )
      AADD( ::s_aResources, cResFileName )
   ENDIF

   RETURN NIL

METHOD UnRegisterResources( )

   LOCAL nI, cResFileName

   FOR nI := 1 TO LEN( ::s_aResources )
      cResFileName := ::s_aResources [ nI ]
      ::s_qRes:unregisterResource_1( &cResFileName )
   NEXT nI

   ASIZE( ::s_aResources, 0 )

   RETURN NIL   
